/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-24 at 08:41:31 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.indexing.v3.model;

/**
 * `UrlNotification` is the resource used in all Indexing API calls. It describes one event in the
 * life cycle of a Web Document.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Indexing API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UrlNotification extends com.google.api.client.json.GenericJson {

  /**
   * Creation timestamp for this notification. Users should _not_ specify it, the field is ignored
   * at the request time.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String notifyTime;

  /**
   * The URL life cycle event that Google is being notified about.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * The object of this notification. The URL must be owned by the publisher of this notification
   * and, in case of `URL_UPDATED` notifications, it _must_ be crawlable by Google.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String url;

  /**
   * Creation timestamp for this notification. Users should _not_ specify it, the field is ignored
   * at the request time.
   * @return value or {@code null} for none
   */
  public String getNotifyTime() {
    return notifyTime;
  }

  /**
   * Creation timestamp for this notification. Users should _not_ specify it, the field is ignored
   * at the request time.
   * @param notifyTime notifyTime or {@code null} for none
   */
  public UrlNotification setNotifyTime(String notifyTime) {
    this.notifyTime = notifyTime;
    return this;
  }

  /**
   * The URL life cycle event that Google is being notified about.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * The URL life cycle event that Google is being notified about.
   * @param type type or {@code null} for none
   */
  public UrlNotification setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  /**
   * The object of this notification. The URL must be owned by the publisher of this notification
   * and, in case of `URL_UPDATED` notifications, it _must_ be crawlable by Google.
   * @return value or {@code null} for none
   */
  public java.lang.String getUrl() {
    return url;
  }

  /**
   * The object of this notification. The URL must be owned by the publisher of this notification
   * and, in case of `URL_UPDATED` notifications, it _must_ be crawlable by Google.
   * @param url url or {@code null} for none
   */
  public UrlNotification setUrl(java.lang.String url) {
    this.url = url;
    return this;
  }

  @Override
  public UrlNotification set(String fieldName, Object value) {
    return (UrlNotification) super.set(fieldName, value);
  }

  @Override
  public UrlNotification clone() {
    return (UrlNotification) super.clone();
  }

}
